#!/usr/bin/env python
# generated by wxGlade 0.4.1 on Fri May  5 17:17:53 2006

# PonyTrainer.py (C) Copyright 2007, Phil Underwood

# This file is part of PonyTrainer.

# PonyTrainer is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.

# PonyTrainer is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.

# You should have received a copy of the GNU General Public License
# along with PonyTrainer; if not, write to the Free Software
# Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

import wx
import wx.grid
import os
import sys
import struct
import re
import ponytalk
import time
import webbrowser
import cdc

global pony

def fptofloat(x):
    (f,) = struct.unpack(">l",x.decode('hex'))
    f = f/16777216.0
    return f

def floattofp(x):
    x = x * 16777216.0
    f = struct.pack(">l",x).encode('hex')
    return f

def hextofloat(x):
    (f,) = struct.unpack(">f",x.decode('hex'))
    return f

def floattohex(x):
    f = struct.pack(">f",x).encode('hex')
    return f

# this dictionary puts the various brightness settings for the
# display module in order
display_dict = { 0:0 ,  1:16,  2:32,  3:48,  4:33,  5:17,  6:34,  7:1 ,\
		 8:35,  9:18, 10:49, 11:36, 12:2 , 13:19, 14:37, 15:50,\
		16:20, 17:38, 18:3 , 19:39, 20:21, 21:4 , 22:40, 23:51,\
		24:22, 25:5 , 26:52, 27:23, 28:41, 29:53, 30:6 , 31:24,\
		32:42, 33:7 , 34:25, 35:43, 36:54, 37:8 , 38:44, 39:26,\
		40:55, 41:9 , 42:27, 43:45, 44:56, 45:10, 46:28, 47:57,\
		48:46, 49:11, 50:29, 51:58, 52:47, 53:12, 54:59, 55:30,\
		56:13, 57:60, 58:31, 59:14, 60:61, 61:15, 62:62, 63:63}
reverse_dict = dict(zip(display_dict.values(),display_dict.keys()))
if os.name == 'nt':
    calibrate_executable = os.path.join(sys.path[0],'calibrate.exe')
    calibrate_executable = re.sub(r'library.zip\\','',calibrate_executable)
else:
    calibrate_executable = os.path.join(sys.path[0],'calibrate')


class PonyFrame(wx.Frame):
    def __init__(self,*args, **kwds):
	self.pony = kwds["pony"]
	del kwds["pony"]
        # begin wxGlade: PonyFrame.__init__
        kwds["style"] = wx.DEFAULT_FRAME_STYLE
        wx.Frame.__init__(self, *args, **kwds)
        self.notebook_1 = wx.Notebook(self, -1, style=0)
        self.notebook_1_pane_4 = wx.Panel(self.notebook_1, -1)
        self.notebook_1_pane_3 = wx.Panel(self.notebook_1, -1)
        self.notebook_1_pane_2 = wx.Panel(self.notebook_1, -1)
        self.sizer_10_staticbox = wx.StaticBox(self.notebook_1_pane_4, -1, "Gravity")
        self.sizer_11_staticbox = wx.StaticBox(self.notebook_1_pane_4, -1, "Magnetism")
        self.notebook_1_pane_1 = wx.Panel(self.notebook_1, -1)
        
        # Menu Bar
        self.PonyFrame1_menubar = wx.MenuBar()
        wxglade_tmp_menu = wx.Menu()
        self.loadraw = wx.MenuItem(wxglade_tmp_menu, wx.NewId(), "Load raw calibration data", "", wx.ITEM_NORMAL)
        wxglade_tmp_menu.AppendItem(self.loadraw)
        self.saveraw = wx.MenuItem(wxglade_tmp_menu, wx.NewId(), "Save Raw Sensor Data", "", wx.ITEM_NORMAL)
        wxglade_tmp_menu.AppendItem(self.saveraw)
        self.savecal = wx.MenuItem(wxglade_tmp_menu, wx.NewId(), "Save calibration data", "", wx.ITEM_NORMAL)
        wxglade_tmp_menu.AppendItem(self.savecal)
        self.applydata = wx.MenuItem(wxglade_tmp_menu, wx.NewId(), "Apply saved calibration data", "", wx.ITEM_NORMAL)
        wxglade_tmp_menu.AppendItem(self.applydata)
        self.resetlegs = wx.MenuItem(wxglade_tmp_menu, wx.NewId(), "Reset leg count", "", wx.ITEM_NORMAL)
        wxglade_tmp_menu.AppendItem(self.resetlegs)
        wxglade_tmp_menu.AppendSeparator()
        self.exitsave = wx.MenuItem(wxglade_tmp_menu, wx.NewId(), "Exit and save changes", "", wx.ITEM_NORMAL)
        wxglade_tmp_menu.AppendItem(self.exitsave)
        self.exitdontsave = wx.MenuItem(wxglade_tmp_menu, wx.NewId(), "Exit without saving changes", "", wx.ITEM_NORMAL)
        wxglade_tmp_menu.AppendItem(self.exitdontsave)
        self.PonyFrame1_menubar.Append(wxglade_tmp_menu, "&File")
        wxglade_tmp_menu = wx.Menu()
        self.copy = wx.MenuItem(wxglade_tmp_menu, wx.NewId(), "Copy (Ctrl-C)", "", wx.ITEM_NORMAL)
        wxglade_tmp_menu.AppendItem(self.copy)
        self.PonyFrame1_menubar.Append(wxglade_tmp_menu, "&Edit")
        wxglade_tmp_menu = wx.Menu()
        self.contents = wx.MenuItem(wxglade_tmp_menu, wx.NewId(), "&Contents", "", wx.ITEM_NORMAL)
        wxglade_tmp_menu.AppendItem(self.contents)
        wxglade_tmp_menu.AppendSeparator()
        self.show_about = wx.MenuItem(wxglade_tmp_menu, wx.NewId(), "&About...", "", wx.ITEM_NORMAL)
        wxglade_tmp_menu.AppendItem(self.show_about)
        self.PonyFrame1_menubar.Append(wxglade_tmp_menu, "&Help")
        self.SetMenuBar(self.PonyFrame1_menubar)
        # Menu Bar end
        self.statusbar = self.CreateStatusBar(2, 0)
        self.label_1 = wx.StaticText(self.notebook_1_pane_1, -1, "Laser brightness")
        self.laser_slider = wx.Slider(self.notebook_1_pane_1, -1, 128, 0, 255)
        self.label_2 = wx.StaticText(self.notebook_1_pane_1, -1, "Display brightness")
        self.display_slider = wx.Slider(self.notebook_1_pane_1, -1, 32, 1, 63)
        self.switching_time = wx.Slider(self.notebook_1_pane_1, -1, 64, 16, 255)
        self.time_text = wx.StaticText(self.notebook_1_pane_1, -1, "500ms")
        self.shutdown_time = wx.Slider(self.notebook_1_pane_1, -1, 60, 0, 300)
        self.shutdown_text = wx.StaticText(self.notebook_1_pane_1, -1, "60s")
        self.read_delay_time = wx.Slider(self.notebook_1_pane_1, -1, 15, 5, 50)
        self.read_delay_text = wx.StaticText(self.notebook_1_pane_1, -1, "1.5s")
        self.secure_on = wx.CheckBox(self.notebook_1_pane_1, -1, "Require two button presses to turn on")
        self.hold = wx.CheckBox(self.notebook_1_pane_1, -1, "Hold recorded values on the display")
        self.debug = wx.CheckBox(self.notebook_1_pane_1, -1, "Debug Mode")
        self.mode = wx.Choice(self.notebook_1_pane_1, -1, choices=["Hold", "Save", "Raw", "Hi-res", "400g", "Program"])
        self.cal_list = wx.grid.Grid(self.notebook_1_pane_2, -1, size=(1, 1))
        self.button_3 = wx.Button(self.notebook_1_pane_2, -1, "Calibrate Pony")
        self.button_1 = wx.Button(self.notebook_1_pane_2, -1, "Calculate Errors")
        self.data_list = wx.grid.Grid(self.notebook_1_pane_3, -1, size=(1, 1))
        self.grav_grid = wx.grid.Grid(self.notebook_1_pane_4, -1, size=(1, 1))
        self.mag_grid = wx.grid.Grid(self.notebook_1_pane_4, -1, size=(1, 1))

        self.__set_properties()
        self.__do_layout()

        self.Bind(wx.EVT_MENU, self.load_raw, self.loadraw)
        self.Bind(wx.EVT_MENU, self.save_raw, self.saveraw)
        self.Bind(wx.EVT_MENU, self.save_calibration, self.savecal)
        self.Bind(wx.EVT_MENU, self.apply_data, self.applydata)
        self.Bind(wx.EVT_MENU, self.reset_legs, self.resetlegs)
        self.Bind(wx.EVT_MENU, self.exit_and_save, self.exitsave)
        self.Bind(wx.EVT_MENU, self.exit_and_dont_save, self.exitdontsave)
        self.Bind(wx.EVT_MENU, self.copy_clipboard, self.copy)
        self.Bind(wx.EVT_MENU, self.show_contents, self.contents)
        self.Bind(wx.EVT_MENU, self.ShowAbout, self.show_about)
        self.Bind(wx.EVT_COMMAND_SCROLL, self.laser_scroll, self.laser_slider)
        self.Bind(wx.EVT_COMMAND_SCROLL, self.display_scroll, self.display_slider)
        self.Bind(wx.EVT_COMMAND_SCROLL, self.switch_adjust, self.switching_time)
        self.Bind(wx.EVT_COMMAND_SCROLL, self.shutdown_adjust, self.shutdown_time)
        self.Bind(wx.EVT_COMMAND_SCROLL, self.read_delay_adjust, self.read_delay_time)
        self.Bind(wx.EVT_CHECKBOX, self.dirty, self.secure_on)
        self.Bind(wx.EVT_CHECKBOX, self.dirty, self.hold)
        self.Bind(wx.EVT_CHECKBOX, self.dirty, self.debug)
        self.Bind(wx.EVT_CHOICE, self.dirty, self.mode)
        self.Bind(wx.grid.EVT_GRID_CMD_SELECT_CELL, self.data_range_select, self.cal_list)
        self.Bind(wx.grid.EVT_GRID_CMD_RANGE_SELECT, self.data_range_select, self.cal_list)
        self.Bind(wx.EVT_BUTTON, self.run_calibration, self.button_3)
        self.Bind(wx.EVT_BUTTON, self.calc_errors, self.button_1)
        self.Bind(wx.grid.EVT_GRID_CMD_SELECT_CELL, self.data_range_select, self.data_list)
        self.Bind(wx.grid.EVT_GRID_CMD_RANGE_SELECT, self.data_range_select, self.data_list)
        self.Bind(wx.grid.EVT_GRID_CMD_SELECT_CELL, self.data_range_select, self.grav_grid)
        self.Bind(wx.grid.EVT_GRID_CMD_RANGE_SELECT, self.data_range_select, self.grav_grid)
        self.Bind(wx.grid.EVT_GRID_CMD_SELECT_CELL, self.data_range_select, self.mag_grid)
        self.Bind(wx.grid.EVT_GRID_CMD_RANGE_SELECT, self.data_range_select, self.mag_grid)
        # end wxGlade
        self.Bind(wx.EVT_CLOSE, self.closer)
        self.Bind(wx.EVT_TIMER, self.ticker)

    def __set_properties(self):
        # begin wxGlade: PonyFrame.__set_properties
        self.SetTitle("PonyTrainer")
        self.SetSize((756, 461))
        self.statusbar.SetStatusWidths([-1, -1])
        # statusbar fields
        statusbar_fields = ["Device", "Status"]
        for i in range(len(statusbar_fields)):
            self.statusbar.SetStatusText(statusbar_fields[i], i)
        self.laser_slider.SetMinSize((200, 20))
        self.display_slider.SetMinSize((200, 20))
        self.switching_time.SetMinSize((200, 20))
        self.switching_time.SetToolTipString("Time taken for the display to switch between compass and clino readings. This also affects the responsiveness of various other operations")
        self.shutdown_time.SetMinSize((200, 20))
        self.shutdown_time.SetToolTipString("Time between the last button press and the device turning itself off. 0 means it stays on until turned off")
        self.read_delay_time.SetMinSize((200, 20))
        self.read_delay_time.SetToolTipString("Time between pressing the button and the reading being taken")
        self.secure_on.SetToolTipString("If checked, you need to press the button twice within (switching time x 2) to turn the unit on. Useful to prevent it accidentally being turned on.")
        self.secure_on.SetValue(1)
        self.hold.SetToolTipString("If checked, once you have recorded a reading (holding down the button), the display will continue to show that data until the next reading is acquired. If unchecked, as soon as you let go of the button, the display goes back to \"real-time\" mode.")
        self.debug.SetToolTipString("When checked, the pony will display error codes if there are sensor problems. However, it may occasionally produce \"false\" error readings from time to time.")
        self.mode.SetToolTipString("Hold means that no data is recorded when the button is pressed, but the device holds the readings on the display.\nSave will record the displayed data into the devices memory.\nRaw is used for calibration only.\nHi-res displays and saves the compass reading to 1/10 of a degree (you need to imagine a decimal point before the last digit on the display)\n400g is a european system where each quarter-circle contains 100 degrees\nProgram puts the device into firmware upgrade mode")
        self.mode.SetSelection(0)
        self.cal_list.CreateGrid(0, 7)
        self.cal_list.SetRowLabelSize(0)
        self.cal_list.SetColLabelValue(0, "Reading")
        self.cal_list.SetColLabelValue(1, "RCompass")
        self.cal_list.SetColLabelValue(2, "Compass")
        self.cal_list.SetColLabelValue(3, "RClino")
        self.cal_list.SetColLabelValue(4, "Clino")
        self.cal_list.SetColLabelValue(5, "Error")
        self.cal_list.SetColLabelValue(6, "Include")
        self.data_list.CreateGrid(0, 3)
        self.data_list.SetRowLabelSize(0)
        self.data_list.EnableEditing(0)
        self.data_list.EnableDragRowSize(0)
        self.data_list.SetColLabelValue(0, "Reading")
        self.data_list.SetColLabelValue(1, "Compass")
        self.data_list.SetColLabelValue(2, "Clino")
        self.grav_grid.CreateGrid(4, 4)
        self.grav_grid.SetRowLabelSize(0)
        self.grav_grid.SetColLabelSize(0)
        self.mag_grid.CreateGrid(4, 4)
        self.mag_grid.SetRowLabelSize(0)
        self.mag_grid.SetColLabelSize(0)
        # end wxGlade
        self.cal_list.AutoSize()
        attr = wx.grid.GridCellAttr()
        attr.SetReadOnly(True)
        for i in range(6):
            self.cal_list.SetColAttr(i,attr)
        attr = wx.grid.GridCellAttr()
        attr.SetEditor(wx.grid.GridCellBoolEditor())
        attr.SetRenderer(wx.grid.GridCellBoolRenderer())
        self.cal_list.SetColFormatBool(6)
        self.cal_list.SetColAttr(6,attr)
        self.data_list.AutoSize()
	self.mag_matrix = []
	self.grav_matrix = []

    def __do_layout(self):
        # begin wxGlade: PonyFrame.__do_layout
        sizer_1 = wx.BoxSizer(wx.VERTICAL)
        sizer_9 = wx.BoxSizer(wx.HORIZONTAL)
        sizer_11 = wx.StaticBoxSizer(self.sizer_11_staticbox, wx.HORIZONTAL)
        sizer_10 = wx.StaticBoxSizer(self.sizer_10_staticbox, wx.HORIZONTAL)
        sizer_5 = wx.BoxSizer(wx.HORIZONTAL)
        sizer_6 = wx.BoxSizer(wx.VERTICAL)
        sizer_8 = wx.BoxSizer(wx.HORIZONTAL)
        sizer_2 = wx.BoxSizer(wx.VERTICAL)
        sizer_7_copy_1 = wx.BoxSizer(wx.HORIZONTAL)
        sizer_7_copy = wx.BoxSizer(wx.HORIZONTAL)
        sizer_7 = wx.BoxSizer(wx.HORIZONTAL)
        sizer_4 = wx.BoxSizer(wx.HORIZONTAL)
        sizer_3 = wx.BoxSizer(wx.HORIZONTAL)
        sizer_3.Add(self.label_1, 0, wx.ALL|wx.ALIGN_RIGHT|wx.ALIGN_CENTER_VERTICAL|wx.FIXED_MINSIZE, 3)
        sizer_3.Add(self.laser_slider, 0, wx.ALL|wx.ALIGN_CENTER_VERTICAL, 3)
        sizer_2.Add(sizer_3, 0, wx.SHAPED, 0)
        sizer_4.Add(self.label_2, 0, wx.ALL|wx.ALIGN_RIGHT|wx.ALIGN_CENTER_VERTICAL, 3)
        sizer_4.Add(self.display_slider, 0, wx.ALL|wx.ALIGN_CENTER_VERTICAL, 3)
        sizer_2.Add(sizer_4, 0, 0, 0)
        label_3 = wx.StaticText(self.notebook_1_pane_1, -1, "Switching time")
        sizer_7.Add(label_3, 0, wx.ALL|wx.ALIGN_CENTER_VERTICAL, 3)
        sizer_7.Add(self.switching_time, 0, wx.ALL|wx.ALIGN_CENTER_VERTICAL, 3)
        sizer_7.Add(self.time_text, 0, wx.ALIGN_CENTER_VERTICAL, 0)
        sizer_2.Add(sizer_7, 0, 0, 0)
        label_3_copy = wx.StaticText(self.notebook_1_pane_1, -1, "Time to shutdown")
        sizer_7_copy.Add(label_3_copy, 0, wx.ALL|wx.ALIGN_CENTER_VERTICAL, 3)
        sizer_7_copy.Add(self.shutdown_time, 0, wx.ALL|wx.ALIGN_CENTER_VERTICAL, 3)
        sizer_7_copy.Add(self.shutdown_text, 0, wx.ALIGN_CENTER_VERTICAL, 0)
        sizer_2.Add(sizer_7_copy, 0, 0, 0)
        label_3_copy_1 = wx.StaticText(self.notebook_1_pane_1, -1, "Read delay time")
        sizer_7_copy_1.Add(label_3_copy_1, 0, wx.ALL|wx.ALIGN_CENTER_VERTICAL, 3)
        sizer_7_copy_1.Add(self.read_delay_time, 0, wx.ALL|wx.ALIGN_CENTER_VERTICAL, 3)
        sizer_7_copy_1.Add(self.read_delay_text, 0, wx.ALIGN_CENTER_VERTICAL, 0)
        sizer_2.Add(sizer_7_copy_1, 0, 0, 0)
        sizer_2.Add(self.secure_on, 0, wx.ALL, 3)
        sizer_2.Add(self.hold, 0, wx.ALL, 3)
        sizer_2.Add(self.debug, 0, wx.ALL, 3)
        sizer_2.Add(self.mode, 0, 0, 0)
        self.notebook_1_pane_1.SetSizer(sizer_2)
        sizer_6.Add(self.cal_list, 1, wx.EXPAND, 0)
        sizer_8.Add(self.button_3, 0, wx.ALL, 3)
        sizer_8.Add(self.button_1, 0, wx.ALL, 3)
        sizer_6.Add(sizer_8, 0, wx.ALIGN_CENTER_HORIZONTAL, 0)
        self.notebook_1_pane_2.SetSizer(sizer_6)
        sizer_5.Add(self.data_list, 1, wx.EXPAND, 0)
        self.notebook_1_pane_3.SetSizer(sizer_5)
        sizer_10.Add(self.grav_grid, 1, wx.EXPAND, 0)
        sizer_9.Add(sizer_10, 1, wx.EXPAND, 0)
        sizer_11.Add(self.mag_grid, 1, wx.EXPAND, 0)
        sizer_9.Add(sizer_11, 1, wx.EXPAND, 0)
        self.notebook_1_pane_4.SetSizer(sizer_9)
        self.notebook_1.AddPage(self.notebook_1_pane_1, "Settings")
        self.notebook_1.AddPage(self.notebook_1_pane_2, "Calibrate")
        self.notebook_1.AddPage(self.notebook_1_pane_3, "Data")
        self.notebook_1.AddPage(self.notebook_1_pane_4, "Matrix")
        sizer_1.Add(self.notebook_1, 1, wx.EXPAND, 0)
        self.SetSizer(sizer_1)
        self.Layout()
        self.SetSize((756, 461))
        # end wxGlade
        # ok - here we do our detection for our stuff
        # laser
        self.version = self.pony.SendText('GX')
        if self.version == '':
        	self.version = 1
        else:
        	self.version = int(self.version)
        if (int(self.version) not in (2,3)):
			wx.MessageBox("Your pony firmware is version %d.\nThis software only works with version 2 or 3" % self.version,"Warning")
			sys.exit(0)
        if self.version == 3:
            self.decode_float = fptofloat
            self.encode_float = floattofp
        else:
            self.decode_float = hextofloat
            self.encode_float = floattohex
        self.laser_slider.SetValue(int(self.pony.SendText('VLaser'),16))
        self.display_slider.SetValue(reverse_dict[int(self.pony.SendText('VDisplay'),16)])
        self.switching_time.SetValue(int(self.pony.SendText('VTimer'),16))
        self.shutdown_time.SetValue(int(self.pony.SendText('VPower'),16))
        self.read_delay_time.SetValue(int(self.pony.SendText('VSwitch'),16))
        self.secure_on.SetValue(int(self.pony.SendText('VOn')))
        self.hold.SetValue(int(self.pony.SendText('VHold')))
        self.old_mode = int(self.pony.SendText('VMode'))
        debug = self.pony.SendText('VBug')
        if debug=='':
            print "Do not worry about the above error message"
            self.debug.Hide()
        else:
            self.debug.SetValue(int(debug))
        if self.old_mode != 2:
            self.notebook_1_pane_2.Hide()
        if (self.old_mode in (0,2)):
            self.notebook_1_pane_3.Hide()
        else:
            self.get_data()
        self.mode.SetSelection(self.old_mode)
	self.get_matrices()
	self.update_matrices()
        self.switch_adjust(1)
        self.shutdown_adjust(1)
        self.read_delay_adjust(1)
        self.filthy = False
        self.cal_data_filthy = False
        self.selection = ""
        self.timer = wx.Timer(self);
        self.timer.Start(1000);

    def get_matrices(self):
	self.grav_matrix = []
        self.mag_matrix = []
	for i in range(12):
		text = 'SG%1X' % i
                self.grav_matrix.append(self.decode_float(self.pony.SendText(text))) 
		text = 'SM%1X' % i
                self.mag_matrix.append(self.decode_float(self.pony.SendText(text)))
        
    def update_matrices(self):
        for i in range(12):
            self.mag_grid.SetCellValue(i % 3, i / 3, '%6f' % self.mag_matrix[i])
            self.grav_grid.SetCellValue(i % 3, i / 3, '%6f' % self.grav_matrix[i])
	for j in range(3):
		self.grav_grid.SetCellValue(3,j,"0")
		self.mag_grid.SetCellValue(3,j,"0")
	self.grav_grid.SetCellValue(3,3,"1")
	self.mag_grid.SetCellValue(3,3,"1")

    def get_data(self):
        #here we interrogate the pony and read all the stored data...
        leg_count = int(self.pony.SendText('VReadings'),16)
        self.data_list.AppendRows(leg_count)
        for i in range(leg_count):
            hexi = "%04X" % i
            resp = self.pony.SendText("Read %s" % hexi)
            (compass,clino) = map(float,resp.split())
            if self.old_mode == 3:
                compass = compass / 10
                clino = clino / 10
            self.data_list.SetCellValue(i,0,str(i))
            self.data_list.SetCellValue(i,1,str(compass))
            self.data_list.SetCellValue(i,2,str(clino))
        self.data_list.AutoSize()

    def laser_scroll(self, event): # wxGlade: PonyFrame.<event_handler>
        self.filthy = True
        self.pony.CheckResponse('VLaser',self.laser_slider.GetValue(),2)

    def display_scroll(self, event): # wxGlade: PonyFrame.<event_handler>
        self.filthy = True
        self.pony.CheckResponse('VDisplay',display_dict[self.display_slider.GetValue()],2)

    def ShowAbout(self, event): # wxGlade: PonyFrame.<event_handler>
        wx.MessageBox("PonyTrainer\nCompanion program for the Shetland Attack Pony\n(c) 2007 Phil Underwood","About PonyTrainer")

    def switch_adjust(self, event): # wxGlade: PonyFrame.<event_handler>
        self.filthy = True
        time = self.switching_time.GetValue()*1000/128
        self.time_text.SetLabel("%sms" % time)

    def shutdown_adjust(self, event): # wxGlade: PonyFrame.<event_handler>
        self.filthy = True
        time = self.shutdown_time.GetValue()
        self.shutdown_text.SetLabel("%ss" % time)

    def read_delay_adjust(self, event): # wxGlade: PonyFrame.<event_handler>
        time = float(self.read_delay_time.GetValue())/10
        self.read_delay_text.SetLabel("%gs" % time)

    def gen_cal_script(self,encoding):
        script = ''
        for i in range(12):
            text = 'SG%1X ' % i
            script  += text + encoding(self.grav_matrix[i]) + "\n"
            text = 'SM%1X ' % i
            script  += text + encoding(self.mag_matrix[i]) + "\n"
        return script

    def read_cal_script(self,script): # this is purely for reading an external file...
        for line in script:
            patt = re.search(r"S(\w)(\w) (\w+)",line)
            if patt:
                i = int(patt.groups()[1],16)
                f = hextofloat(patt.groups()[2])
                print f
                if patt.groups()[0]=='M':
                    self.mag_matrix[i] = f
                if patt.groups()[0]=='G':
                    self.grav_matrix[i] = f


    def save_calibration(self, event): # wxGlade: PonyFrame.<event_handler>
	fname = wx.FileSelector("Save as...",wildcard = "*.cal",flags = wx.SAVE)
	try:
		f = open(fname,"w")
		f.writelines(gen_cal_script(hextofloat))
		f.close()
	except:
		wx.MessageBox("Error writing file %s" % fname)

    def apply_data(self, event): # wxGlade: PonyFrame.<event_handler>
	fname = wx.FileSelector("Open calibration data...",wildcard = "*.cal",flags = wx.OPEN)
#	try:
        f = open(fname,"r")
        self.read_cal_script(f.readlines())
        f.close()
#	except:
#		wx.MessageBox("Error reading file %s" % fname)
	self.cal_data_filthy=True
	self.update_matrices()

    def reset_legs(self, event): # wxGlade: PonyFrame.<event_handler>
        self.pony.CheckResponse("VReadings",0,4)
        
    def load_raw(self, event): # wxGlade: PonyFrame.<event_handler>
        if self.old_mode != 2:
            wx.MessageBox("Raw calibration data","The SAP does not currently hold raw sensor data, so this command is disables",wx.OK)
        fname = wx.FileSelector("Raw calibration data",wildcard = "*.txt",flags = wx.OPEN)
        if fname:
            try:
                f = open(fname,"r")
            except IOError:
                wx.MessageBox("Error opening file %s" % fname,"Error")
            i = 0
            self.cal_data = {}
            self.cal_indices = {}
            #clear any previous data
            if self.cal_list.GetNumberRows() > 0:
                self.cal_list.DeleteRows(0,self.cal_list.GetNumberRows())
            for line in f.readlines():
                # ignore lines startign with "#"
                if line.strip().startswith("#"): continue
                (leg,compass,clino) = line.split()
                self.cal_list.AppendRows(1)
                self.cal_list.SetCellValue(i,0,leg)
                self.cal_list.SetCellValue(i,1,compass)
                self.cal_list.SetCellValue(i,3,clino)
                self.cal_list.SetCellValue(i,6,"1")
                self.cal_indices[leg] = i
                sensors = self.pony.SendText("Read %04X" % int(leg))
                raws = [self.decode_float(x) for x in sensors.split()]
                vals.extend(list(raws))
                vals.extend([float(compass),float(clino)])
                self.cal_data[leg] = vals
                print vals
                i = i+1
            self.cal_list.SetSize(self.cal_list.GetSize())
                
    def exit_and_save(self, event): # wxGlade: PonyFrame.<event_handler>
        mode = self.mode.GetSelection()
        if mode == 5:
            if wx.MessageBox("Changing to programming mode. You will need to run the firmware upgrade program next. Don't forget to save your calibration first!","Warning",wx.OK | wx.CANCEL,self) == wx.CANCEL:
                try:
                    event.Veto()
                except:
                    pass
                return
            else:
                self.pony.SendText("PRG")
                self.pony.SendText("Commit")
                sys.exit(0)
        if mode != self.old_mode:
            if wx.MessageBox("You have changed the recording mode. This will mean that all of the data stored on your device will be deleted. Are you sure you want to go ahead?","Warning",wx.OK | wx.CANCEL,self) == wx.CANCEL:
                try:
                    event.Veto()
                except:
                    pass
                return
            else:
                self.pony.CheckResponse('VMode',mode,2)
        if self.cal_data_filthy:
            if wx.MessageBox("You have calibration data to download. This will affect the accuracy of your device. Are you sure you want to go ahead?","Warning",wx.OK | wx.CANCEL,self) == wx.CANCEL:
                try:
                    event.Veto()
                except:
                    pass
                return
            else:
                for line in gen_cal_script(encode_float):
                    self.pony.SendText(line)
        self.pony.CheckResponse('VTimer',self.switching_time.GetValue(),2)
        self.pony.CheckResponse('VPower',self.shutdown_time.GetValue(),4)
        self.pony.CheckResponse('VSwitch',self.read_delay_time.GetValue(),4)
        self.pony.CheckResponse('VOn',self.secure_on.GetValue(),1)
        self.pony.CheckResponse('VHold',self.hold.GetValue(),1)
        self.pony.CheckResponse('VBug',self.debug.GetValue(),1)
        self.pony.SendText("Commit")
        self.pony.SendText("Quit")
        self.Destroy()

    def exit_and_dont_save(self, event): # wxGlade: PonyFrame.<event_handler>
        self.pony.SendText("Quit")
        self.Destroy()

    def show_contents(self, event): # wxGlade: PonyFrame.<event_handler>
        webbrowser.open("manual.pdf")
        print "Event handler `show_contents' not implemented"
        event.Skip()

    def closer(self, event):
        if event.CanVeto() and self.filthy:
            #offer to commit changes - yes, no, cancel
            answer = wx.MessageBox("Do you wish to save the settings to the SAP?","Close",wx.YES_NO | wx.CANCEL,self)
            if answer == wx.YES:
                self.exit_and_save(event)
                return
            if answer == wx.NO:
                self.exit_and_dont_save(event)
                return
            event.Veto()
            return
        else:
            self.exit_and_dont_save(event)

    def dirty(self, event): # wxGlade: PonyFrame.<event_handler>
        self.filthy = True
        event.Skip()

    def cal_data_dump(self):
        lines = []
        for i in range(self.cal_list.GetNumberRows()):
            #ignore ones not included
            if self.cal_list.GetCellValue(i,6):
                leg = self.cal_list.GetCellValue(i,0)
                lines.append(" ".join(map(str,self.cal_data[leg])))
        return "\n".join(lines)


    def run_calibration(self, event): # wxGlade: PonyFrame.<event_handler>
        print self.cal_data_dump()
        (f_in,f_out) = os.popen2("\"%s\"" % calibrate_executable)
        f_in.write(self.cal_data_dump())
        f_in.close()
        script = ''
        for line in f_out.readlines():
            if line.startswith("#"):
                average_err = line.split()[1]
            else:
		print line
                script.append(line)
        read_cal_script(script)
	self.update_matrices()
        wx.MessageBox("Average error was %s" % average_err)
        self.cal_data_filthy = True
        self.filthy = True

    def calc_errors(self, event): # wxGlade: PonyFrame.<event_handler>
        # run calibrate program form same location as this script
        (f_in,f_out) = os.popen2("\"%s\" -l" % calibrate_executable)
        dump = self.cal_data_dump()
        dump_length = len(dump.split('\n'))
        f_in.write(dump)
        f_in.close()
        #wait for calibrate to finish
        # read stuff from the calibration program
        dlg = wx.ProgressDialog("Calculating errors",\
                                "Progress:",dump_length)
        lines_done = 0
        while 1:
            data = f_out.readline()
            if data=='':
                break
            dlg.Update(lines_done)
            lines_done+=1
            if data.strip().startswith("#"):
                average_err = data.split()[1]
            else:
                items = data.split()
                i = self.cal_indices[items[0]]
                j = 0
                for s in items:
                    self.cal_list.SetCellValue(i,j,s)
                    j = j+1
        dlg.Destroy()
        f_out.close()
        wx.MessageBox("The average error was %s degrees" % average_err)
        

    def copy_clipboard(self, event): # wxGlade: PonyFrame.<event_handler>
        # this copies data from the data tab to the clipboard
        if wx.TheClipboard.Open():
            wx.TheClipboard.SetData(wx.TextDataObject(self.selection))
            wx.TheClipboard.Close()
        event.Skip()

    def data_range_select(self, event): # wxGlade: PonyFrame.<event_handler>
        obj = event.GetEventObject()
        self.selection = ""
        if obj.GetSelectionBlockTopLeft():
            for (tl,br) in zip(obj.GetSelectionBlockTopLeft(),obj.GetSelectionBlockBottomRight()):
                for i in range(tl[0],br[0]+1):
                    for j in range(tl[1],br[1]+1):
                        self.selection += obj.GetCellValue(i,j) + "\t"
                    self.selection = self.selection[:-1] + "\n"
        if obj.GetSelectedCells():
            for i in obj.GetSelectedCells():
                self.selection += obj.GetCellValue(i[0],i[1]) + "\n"
        event.Skip()

    def ticker(self,event): #this gets called every second
        voltage = self.pony.SendText("GVolts") # get volts in mV
        voltage = float(voltage)/1000.0
        current = self.pony.SendText("GI") # get current in mA
        current = int(current)
        self.statusbar.SetStatusText("%.3fV %dmA" % (voltage,current),0)

    def save_raw(self, event): # wxGlade: PonyFrame.<event_handler>
	fname = wx.FileSelector("Save as...",wildcard = "*.txt",flags = wx.SAVE)
        if fname:
            try:
                f = open(fname,"w")
                f.writelines(self.cal_data_dump())
                f.close()
            except:
 		wx.MessageBox("Error writing file %s" % fname)

# end of class PonyFrame


if __name__ == "__main__":
    PonyTrainer = wx.PySimpleApp(0)
    try:
        fh = ponytalk.PonyTalk()
    except cdc.CDCError:
        wx.MessageBox("Could not find SAP")
        sys.exit(0)
    except Exception,msg:
        wx.MessageBox("Error initialising SAP: %s" % str(msg))
    wx.InitAllImageHandlers()
    PonyFrame1 = PonyFrame(None,-1, "",pony=fh)
    PonyTrainer.SetTopWindow(PonyFrame1)
    PonyFrame1.statusbar.SetStatusText("Status: Connected",1)
    PonyFrame1.Show()
    PonyTrainer.MainLoop()
