#!/usr/bin/python
# get_readings.py (C) Copyright 2007, Phil Underwood

# This file is part of PonyTrainer.

# PonyTrainer is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.

# PonyTraine is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.

# You should have received a copy of the GNU General Public License
# along with PonyTrainer; if not, write to the Free Software
# Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

import tty
import sys
import struct
from optparse import OptionParser

parser = OptionParser()
parser.add_option("-d", "--device", default="/dev/ttyUSB0",
                  help="device Pony connects as", metavar="FILE")
parser.add_option("-f", "--field", default=0,type="int",
                  help="field to replace with data")
parser.add_option("-i", "--input", dest = "ifile",metavar="FILE",
                  help="input file name",)
parser.add_option("-s", "--separator", metavar="CHAR",
                  help="split input file on CHAR")
(options,args) = parser.parse_args()

pony =open(options.device,"w+",0)
tty.setraw(pony.fileno())
pony.write("Hello\n")
pony.readline()
if (pony.readline() == "OK\n"):
    sys.stderr.write("Connected\n");
else:
    sys.stderr.write("Awww cuntflap\n");
    exit(0)
pony.write("Mode\n")
calmode = (pony.readline().find('2')!=-1);
pony.readline();
print calmode
if (options.ifile):
    ifile = open(options.ifile,"r")
else:
    ifile = sys.stdin
#print ifile
for s in ifile.readlines():
    items = s.split(options.separator)
    try:
        index = int(items[options.field],16)
    except:
        index = None
    if (index is not None):
        pony.write("R %04X\n" % index)
        if (calmode):
            vals = "".join(pony.readline()[1:].split())
            vals = struct.unpack("!6f",vals.decode("hex"))
            answer = map(str,vals)
        else:
            answer = pony.readline()[1:].split()
        pony.readline()
        outitems = [];
        outitems.extend(items[0:options.field])
        outitems.extend(answer)
        outitems.extend(items[options.field+1:])
        if options.separator:
            print options.separator.join(outitems[0:options.field]), answer
        else:
            print " ".join(outitems)
    else:
        print s
pony.write("Quit\n")
pony.readline()
pony.readline()
    
