#!/usr/bin/python
# ponytalk.py (C) Copyright 2007, Phil Underwood

# This file is part of PonyTrainer.

# PonyTrainer is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.

# PonyTraine is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.

# You should have received a copy of the GNU General Public License
# along with PonyTrainer; if not, write to the Free Software
# Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
import os
import re
import glob
import cdc


class PonyTalk:
	def __init__(self):
		self.fh = cdc.CDC(0x04d8,0x000a)
		self.fh.write("Hello\n")
		if self.get_line().startswith("Hi"):
			if self.get_line().startswith("OK"):
				print "SAP found."
				return None

	def get_line(self):
		temp = self.fh.readline()
		pattern = re.compile(r"[^\w\- ]+")
		return pattern.sub('',temp)

	def CheckResponse(self,text,num,digits):
		# bring up error if don't get back what we expected...
		formata = '%%(text)s %%(num)0%(digits)dX' % vars()
		formatb = '%%(num)0%(digits)dX' % vars()
		text = formata % vars()
		resp = self.SendText(text)
		expected = formatb % vars()
		if resp == expected:
			return resp
		else:
			print("Error! - tried to send %(text)s, received %(resp)s" % vars())

	def SendText(self,text):
	    	#print 'sent:' , text
    		self.fh.write(text+ '\n')
    		#time.sleep(0.1)
    		response = self.get_line()
   		 #print 'got:' , response
    		if self.get_line().startswith('OK'):
        		return response
    		else:
        		print("Tried to send %s, but this was not understood" % text)
        	return ''
